"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const pReduce = require('p-reduce');
/**
 * @file Variables
 * @author Cuttle Cong
 * @date 2018/3/25
 * @description
 */
// export type VariablesController = {
//   always: Function
//   once: Function
//   _type: 'once' | 'always'
// }
class VariablesStore {
    constructor() {
        this.store = {};
    }
    merge(vars) {
        _.merge(this.store, vars);
        return this;
    }
    assign(vars) {
        _.assign(this.store, vars);
        return this;
    }
    setStore(variables) {
        this.store = variables;
        return this;
    }
    set(key, data) {
        _.set(this.store, key, data);
        return this;
    }
    clear() {
        this.store = {};
        return this;
    }
    _get(key) {
        return __awaiter(this, void 0, void 0, function* () {
            const variable = _.get(this.store, key);
            if (!variable) {
                return variable;
            }
            // if (_.isFunction(variable)) {
            //   const vCenter: VariablesController = {
            //     _type: 'once',
            //     once() {
            //       this._type = 'once'
            //     },
            //     always() {
            //       this._type = 'always'
            //     }
            //   }
            //   rlt = await variable(vCenter)
            //   if (vCenter._type === 'once') {
            //     this.set(key, rlt)
            //   }
            // } else {
            //   this.set(key, rlt)
            // }
            return variable;
        });
    }
    get(key) {
        return __awaiter(this, void 0, void 0, function* () {
            if (key) {
                return yield this._get(key);
            }
            const variables = {};
            return yield pReduce(Object.keys(this.store), (set, key) => __awaiter(this, void 0, void 0, function* () {
                variables[key] = yield this._get(key);
                return variables;
            }), variables);
        });
    }
}
exports.default = VariablesStore;
