"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const processAsync_1 = require("../../lib/processAsync");
const runner_1 = require("../../lib/runner");
const EdamError_1 = require("../EdamError");
const pify = require('pify');
const debug = require('debug')('edam:hookify');
function hookify(hook, cwd) {
    if (typeof hook === 'function') {
        return hook;
    }
    if (typeof hook !== 'string') {
        throw new EdamError_1.default('Hook requires string or function, but ' + typeof hook);
    }
    debug('hockify cmd: %s', hook);
    // string
    return function (...args) {
        return __awaiter(this, void 0, void 0, function* () {
            // const string = JSON.stringify(args)
            debug('invoke cmd hook "%s" \n with input: %O', hook, args);
            const env = Object.assign({}, process.env, {
                HOOK_PARAMS: JSON.stringify(args)
            });
            args.forEach(function (arg, index) {
                env['HOOK_PARAMS_' + index] = arg.toString();
            });
            let proc = runner_1.default(hook, {
                env,
                cwd
            });
            const output = yield pify(processAsync_1.default)(proc, `[${hook}]`);
            debug('hook "%s" output: %s', hook, output);
            return;
        });
    };
}
exports.default = hookify;
