"use strict";
/**
 * @file ejs
 * @author Cuttle Cong
 * @date 2018/3/25
 * @description
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const nps = require("path");
function moduleLoader(content, variables) {
    return __awaiter(this, void 0, void 0, function* () {
        const root = this.compiler.root;
        const path = this.path;
        const options = this.options;
        const filename = nps.join(root, path);
        let data = yield require(filename)(variables);
        if (Buffer.isBuffer(data)) {
            data = data.toString();
        }
        if (typeof data === 'string') {
            return data;
        }
        return JSON.stringify(data, null, parseInt(options.indent || 2));
    });
}
module.exports = moduleLoader;
