"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const parseQueryString_1 = require("../../lib/parseQueryString");
function matchMeta(content, path) {
    let meta = {};
    function fillMeta(str) {
        meta.loader = Object.assign({}, parseQueryString_1.default(str));
    }
    let regList = [
        new RegExp(
        // # //
        '^[\\t ]*(?:#|//)' +
            '[\\t ]*' +
            // @loader
            '\\@loader[\\t ]+' +
            // name name
            '(.+)[\\t ]*\\n?'),
        new RegExp(
        // <!--  -->
        '^[\\t ]*<!--' +
            '[\\t ]*' +
            // @loader
            '\\@loader[\\t ]+' +
            // name name
            '(.+)[\\t ]*-->[\\t ]*\\n?'),
        new RegExp(
        // /*  */
        '^[\\t ]*/\\*' +
            '[\\t ]*' +
            // @loader
            '\\@loader[\\t ]+' +
            // name name
            '(.+)[\\t ]*\\*/[\\t ]*\\n?')
    ];
    regList.some(reg => {
        let matched = false;
        content = content.replace(reg, (_, $1) => {
            let str = $1.trim();
            fillMeta(str);
            matched = true;
            return '';
        });
        return matched;
    });
    return {
        content,
        meta
    };
}
exports.default = matchMeta;
