"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const nps = require("path");
const toArray_1 = require("../../lib/toArray");
const _ = require("lodash");
function dynamicGet(valOrCb, args = [], self) {
    return __awaiter(this, void 0, void 0, function* () {
        if (typeof valOrCb === 'function') {
            return yield valOrCb.apply(self, args);
        }
        return valOrCb;
    });
}
function normalize(templateConfig, templateConfigPath) {
    return __awaiter(this, void 0, void 0, function* () {
        yield this.emit('normalize:templateConfig:before', templateConfig);
        const data = yield this.compiler.variables.get();
        if (typeof templateConfig.process === 'function') {
            const processedConfig = yield templateConfig.process(data);
            Object.assign(templateConfig, processedConfig);
        }
        templateConfig.root = yield dynamicGet(templateConfig.root, [data]);
        if (!templateConfig.root) {
            templateConfig.root = './template';
        }
        if (templateConfig.root && templateConfigPath) {
            templateConfig.root = nps.resolve(nps.dirname(templateConfigPath), templateConfig.root);
        }
        templateConfig.ignore = yield dynamicGet(templateConfig.ignore, [
            data
        ]);
        if (!templateConfig.ignore) {
            templateConfig.ignore = [];
        }
        templateConfig.ignore = toArray_1.default(templateConfig.ignore);
        templateConfig.hooks = yield dynamicGet(templateConfig.hooks, [data]);
        templateConfig.variables = yield dynamicGet(templateConfig.variables, [data]);
        templateConfig.loaders = yield dynamicGet(templateConfig.loaders, [data]);
        templateConfig.mappers = yield dynamicGet(templateConfig.mappers, [data]);
        templateConfig.move = yield dynamicGet(templateConfig.move, [data]);
        templateConfig.copy = yield dynamicGet(templateConfig.copy, [data]);
        // templateConfig.remove = await dynamicGet<any>(templateConfig.remove, [data])
        templateConfig.usefulHook = yield dynamicGet(templateConfig.usefulHook, [
            data
        ]);
        _.each(templateConfig.loaders, function (val, key) {
            if (val) {
                templateConfig.loaders[key] = toArray_1.default(val);
            }
        });
        this.templateConfig = templateConfig;
        yield this.emit('normalize:templateConfig:after', this.templateConfig);
        return templateConfig;
    });
}
exports.default = normalize;
