import { EdamConfig, Source } from './types/Options';
import { Track } from './core/extendsConfig';
import { Options } from './core/normalizeSource';
import { AwaitEventEmitter, Logger, PromptProcess } from './types/core';
import { NormalizedTemplateConfig } from './core/plugins/normalize';
import { Plugin } from './core/plugins';
import Compiler from './core/Compiler/index';
import FileProcessor from './core/TreeProcessor/FileProcessor';
import { Constants } from './core/constant';
import TemplateConfig from './types/TemplateConfig';
export declare class Edam extends AwaitEventEmitter {
    config: EdamConfig;
    options: Options;
    inquirer: any;
    logger: Logger;
    protected static sourcePullMethods: {
        [name: string]: (source: Source, edam: Edam) => string;
    };
    protected static utils: {
        [name: string]: any;
    };
    static constants: Constants;
    plugins: Array<Plugin>;
    sourcePullMethods: {
        [name: string]: (source: Source, edam: Edam) => string;
    };
    utils: {
        [name: string]: any;
    };
    constants: Constants;
    track: Track;
    constructor(config?: EdamConfig, options?: Options);
    private normalizeConfig();
    use(plugin: Plugin | Plugin[0], options?: {
        force: boolean;
        removeExisted: boolean;
    }): Edam;
    unuse(pluginCore: Plugin[0]): Edam;
    setConfig(config: EdamConfig): Edam;
    setOption(options: Options): Edam;
    promptProcess: PromptProcess;
    prompt: Function;
    private _promptPrivate(prompts?);
    pull(source?: Source): Promise<void>;
    ready(source?: Source | string): Promise<this>;
    checkConfig(): void;
    run(source?: Source): Promise<FileProcessor>;
    runPlugin(plugin: any): Promise<any>;
    registerPlugins(plugins?: [(options: any, edam: Edam) => void, any][]): Promise<void>;
    process(templateConfigPath?: string): Promise<FileProcessor>;
    templateConfig: NormalizedTemplateConfig | TemplateConfig;
    templateConfigPath: string;
    compiler: Compiler;
}
declare function edam(config: EdamConfig, options: Options): Edam;
export { default as mockPrompts } from './mockPrompts';
export { default as Compiler } from './core/Compiler/index';
export { default as FileProcessor } from './core/TreeProcessor/FileProcessor';
export default edam;
