"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @file merge
 * @author Cuttle Cong
 * @date 2018/3/22
 * @description
 */
const _ = require("lodash");
function getExtendsMerge(option = { concatKeys: [] }) {
    return function (source, ...objects) {
        return _.mergeWith(source, ...objects, function customizer(sourceVal, extendsVal, key) {
            if ((option.concatKeys === '*' || option.concatKeys.includes(key))) {
                return _.uniq((extendsVal || []).concat(sourceVal || []));
            }
            if (Array.isArray(extendsVal)) {
                return extendsVal;
            }
            if (Array.isArray(sourceVal)) {
                return sourceVal;
            }
        });
    };
}
exports.default = getExtendsMerge;
