"use strict";
/* eslint-disable */
// Forked from https://github.com/jaz303/git-clone/blob/master/index.js
// use cross-spawn, instead spawn
Object.defineProperty(exports, "__esModule", { value: true });
const processAsync_1 = require("./processAsync");
var pify = require('pify');
var spawn = require('cross-spawn');
function _checkout(checkout, { targetPath = '', git = 'git' } = {}, cb) {
    var args = ['checkout', checkout];
    var process = spawn(git, args, { cwd: targetPath });
    processAsync_1.default(process, 'git checkout', cb);
}
function clone(repo, targetPath, opts, cb) {
    if (typeof opts === 'function') {
        cb = opts;
        opts = null;
    }
    opts = opts || {};
    var git = opts.git || 'git';
    var args = ['clone'];
    if (opts.shallow) {
        args.push('--depth');
        args.push('1');
        args.push('--recurse-submodules');
        args.push('-j8');
    }
    args.push('--');
    args.push(repo);
    args.push(targetPath);
    var process = spawn(git, args);
    processAsync_1.default(process, 'git clone', function (err, stdout) {
        if (opts.checkout) {
            checkout();
        }
        else {
            cb && cb();
        }
    });
    function checkout() {
        _checkout(opts.checkout, { targetPath, git }, cb);
    }
}
function _pullForce(targetPath, cb) {
    var process = spawn('git', ['pull', '--force', '--allow-unrelated-histories'], {
        cwd: targetPath
    });
    processAsync_1.default(process, 'git pull', cb);
}
exports.default = pify(clone);
exports.checkout = pify(_checkout);
exports.pullForce = pify(_pullForce);
