"use strict";
/**
 * @file isGitUrl
 * @author Cuttle Cong
 * @date 2018/3/23
 * @description
 */
Object.defineProperty(exports, "__esModule", { value: true });
function isExact(url) {
    url = url.trim();
    return (/^(?:git|ssh|https?|git@[-\w.]+):(\/\/)?(.*?)(\.git)?(\/?|#[-\d\w._]+?)$/.test(url));
}
exports.isExact = isExact;
function isGitUrl(url) {
    url = url.trim();
    const p = isExact(url);
    if (p)
        return p;
    if (/^github:.+?\/.+?(\/.+?)?/.test(url)) {
        return true;
    }
    const chunks = url.split('/');
    if (chunks.length === 2 && !chunks[0].startsWith('@')) {
        return true;
    }
}
exports.default = isGitUrl;
