"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mm = require("micromatch");
const toArray_1 = require("./toArray");
const lodash_1 = require("lodash");
function isMatch(value, m) {
    if (lodash_1.isString(m) || lodash_1.isArray(m)) {
        return !!(mm([value], m, { matchBase: true, dot: true }).length);
    }
    if (m instanceof RegExp) {
        return m.test(value);
    }
    if (typeof m === 'function') {
        return !!m(value);
    }
    throw new TypeError('isMatch requires glob[]/glob/regexp/function, but ' + m);
}
exports.isMatch = isMatch;
function match(value, m) {
    const list = toArray_1.default(value);
    return list.filter(val => isMatch(val, m));
}
exports.default = match;
