"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cacheParseGithubUrl = require("parse-github-url");
const parseQueryString_1 = require("./parseQueryString");
const isGitUrl_1 = require("./isGitUrl");
function parseGithubUrl(url) {
    return Object.assign({}, cacheParseGithubUrl(url));
}
function parse(url) {
    url = url.trim();
    let obj;
    const { query, name } = parseQueryString_1.default(url);
    url = name;
    if (/^github:/.test(url) || (url.split('/').length === 2 && !isGitUrl_1.isExact(url))) {
        obj = parseGithubUrl(url.replace(/^github:/, ''));
        url = `https://github.com/${obj.repo}.git`;
    }
    else {
        obj = parseGithubUrl(url);
    }
    // https://github.com/picidaejs/picidaejs/blob/b52330e3326279de7e4458b3c62b5bf862bc5d21/src/index.js#L1
    let matched;
    if (obj.branch === 'blob' &&
        (matched = obj.blob.match(/^[a-z0-9]+(?=\/)/i))) {
        obj.branch = matched[0];
        obj.filepath = obj.filepath.replace(new RegExp('^' + matched[0] + '\\/'), '');
    }
    obj.checkout = obj.branch;
    delete obj.branch;
    return Object.assign({}, obj, query, { url });
}
exports.default = parse;
