"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @file resolve
 * @author Cuttle Cong
 * @date 2018/3/25
 * @description
 */
const resolve = require("resolve");
const nps = require("path");
const globalModulePath = require('global-modules');
function cusResolve(id, options) {
    options = Object.assign({
        cwd: process.cwd(),
        safe: true,
        global: false
    }, options);
    const opt = {
        basedir: options.cwd,
        extensions: ['.js', '.json']
    };
    try {
        return resolve.sync(id, opt);
    }
    catch (err) {
        if (err.code === 'MODULE_NOT_FOUND') {
            if (options.global) {
                return cusResolve(id, Object.assign({}, options, { cwd: globalModulePath, global: false }));
            }
            if (options.safe) {
                // 'react' -> './react'
                if (!nps.isAbsolute(id) && !id.trimLeft().startsWith('.')) {
                    return cusResolve(`./${id}`, options);
                }
                return false;
            }
            throw err;
        }
        else {
            throw err;
        }
    }
}
exports.default = cusResolve;
