"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const walli_1 = require("walli");
const { createVerifiableClass } = walli_1.util;
const sourceConfig = createVerifiableClass({
    // getInitialRule() {
    //   return
    // },
    _check(req) {
        return walli_1.eq({
            cacheDir: walli_1.oneOf([walli_1.boolean, walli_1.string]).optional,
            output: walli_1.string.optional,
            plugins: walli_1.arrayOf(walli_1.eq([walli_1.function_, walli_1.any])).optional,
            storePrompts: walli_1.boolean.optional,
            pull: walli_1.leq({
                npmClient: walli_1.oneOf(['yarn', 'npm']).options,
                git: walli_1.oneOf(['clone', 'download']).options
            }).optional
        }).check(req);
    },
    getDisplayName() {
        return 'sourceConfig';
    }
}, { ParentClass: walli_1.Equal });
const strictSource = createVerifiableClass({
    _check(req) {
        return walli_1.leq({
            type: walli_1.oneOf(['file', 'git', 'npm']),
            url: walli_1.string,
            config: sourceConfig().optional,
            checkout: walli_1.string.optional,
            version: walli_1.string.optional
        }).check(req);
    },
    getDisplayName() {
        return 'strictSource';
    }
});
const source = createVerifiableClass({
    _check(req) {
        return walli_1.oneOf([strictSource(), walli_1.string]).check(req);
    },
    getDisplayName() {
        return 'source';
    }
});
exports.rc = walli_1.leq({
    source: source().optional,
    // cacheDir: oneOf([boolean, string]).optional,
    alias: walli_1.objectOf(source()).optional,
    extends: walli_1.oneOf([walli_1.string, walli_1.arrayOf(walli_1.string)]).optional,
    // output: string.optional,
    // plugins: arrayOf(eq([function_, any])).optional,
    // pull: leq({
    //   npmClient: oneOf(['yarn', 'npm']).optional,
    //   git: oneOf(['clone', 'download']).optional
    // }).optional,
    storePrompts: walli_1.boolean.optional
}).assign(sourceConfig());
exports.edam = exports.rc.assign(walli_1.leq({
    source: source().optional,
    name: walli_1.string.optional,
    updateNotify: walli_1.boolean.optional,
    yes: walli_1.boolean.optional,
    silent: walli_1.boolean.optional
}));
